import { AfterContentInit, EventEmitter, OnDestroy, QueryList } from '@angular/core';
import { HiOptionGroupComponent } from './hi-option-group.component';
import { HiOptionComponent } from './hi-option.component';
import { Subscription } from 'rxjs/Subscription';
import { HiOptionLiComponent } from './hi-option-li.component';
import { TFilterOption } from './hi-option.pipe';
export declare class HiOptionContainerComponent implements AfterContentInit, OnDestroy {
    private _listOfSelectedValue;
    private _searchValue;
    isInit: boolean;
    isAddTagOptionDisplay: boolean;
    listOfAllTemplateOption: HiOptionComponent[];
    optionSubscription: Subscription;
    groupSubscription: Subscription;
    listOfTagOption: HiOptionComponent[];
    listOfFilterOption: HiOptionComponent[];
    activatedOption: HiOptionComponent;
    /** can not use ViewChild since it will match sub options in option group **/
    listOfHiOptionLiComponent: QueryList<HiOptionLiComponent>;
    listOfHiOptionComponent: QueryList<HiOptionComponent>;
    listOfHiOptionGroupComponent: QueryList<HiOptionGroupComponent>;
    hiListOfSelectedValueChange: EventEmitter<any[]>;
    hiListOfTemplateOptionChange: EventEmitter<HiOptionComponent[]>;
    hiClickOption: EventEmitter<void>;
    hiScrollToBottom: EventEmitter<void>;
    hiMode: string;
    hiServerSearch: boolean;
    hiFilterOption: TFilterOption;
    hiMaxMultipleCount: number;
    hiNotFoundContent: string;
    compareWith: (o1: any, o2: any) => boolean;
    hiSearchValue: string;
    hiListOfSelectedValue: any[];
    addTagOption(): void;
    clickOption(option: HiOptionComponent, isPressEnter: boolean): void;
    onKeyDownUl(e: KeyboardEvent): void;
    resetActiveOption(): void;
    clearActivatedOption(): void;
    setActiveOption(option: HiOptionComponent, scroll?: boolean): void;
    scrollIntoView(): void;
    updateSelectedOption(option: HiOptionComponent, isPressEnter: boolean): void;
    refreshListOfTagOption(): void;
    refreshListOfAllTemplateOption(): void;
    refreshAllOptionStatus(isTemplateOptionChange: boolean): void;
    updateListOfFilterOption(): void;
    /** watch options change in option group **/
    watchSubOptionChanges(): void;
    unsubscribeGroup(): void;
    unsubscribeOption(): void;
    readonly isTagsMode: boolean;
    readonly isMultipleOrTags: boolean;
    readonly isNotFoundDisplay: boolean;
    updateAddTagOptionDisplay(): void;
    dropDownScroll(e: MouseEvent, ul: HTMLUListElement): void;
    ngAfterContentInit(): void;
    ngOnDestroy(): void;
}
