import { animate, state, style, transition, trigger } from '@angular/animations';
import { Component, ElementRef, EventEmitter, Input, Output, Renderer2, ViewChild } from '@angular/core';
var HiSelectTopControlComponent = /** @class */ (function () {
    function HiSelectTopControlComponent(renderer) {
        this.renderer = renderer;
        this._listTemplateOfOption = [];
        this.listOfCachedSelectedOption = [];
        this.isComposing = false;
        // tslint:disable-next-line:no-any
        this.hiListOfSelectedValueChange = new EventEmitter();
        this.hiOnSearch = new EventEmitter();
        this.hiMode = 'default';
        this.hiShowSearch = false;
        this.hiDisabled = false;
        this.hiOpen = false;
    }
    Object.defineProperty(HiSelectTopControlComponent.prototype, "hiListOfSelectedValue", {
        // tslint:disable-next-line:no-any
        get: 
        // tslint:disable-next-line:no-any
        function () {
            return this._listOfSelectedValue;
        },
        set: 
        // tslint:disable-next-line:no-any
        function (value) {
            this._listOfSelectedValue = value;
            this.updateListOfCachedOption();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HiSelectTopControlComponent.prototype, "hiListTemplateOfOption", {
        get: function () {
            return this._listTemplateOfOption;
        },
        set: function (value) {
            this._listTemplateOfOption = value;
            this.updateListOfCachedOption();
        },
        enumerable: true,
        configurable: true
    });
    /** cached selected option list **/
    /** cached selected option list **/
    HiSelectTopControlComponent.prototype.updateListOfCachedOption = /** cached selected option list **/
    function () {
        var _this = this;
        if (this.isSingleMode) {
            var selectedOption = this.hiListTemplateOfOption.find(function (o) { return _this.compareWith(o.hiValue, _this.hiListOfSelectedValue[0]); });
            if (selectedOption) {
                this.listOfCachedSelectedOption = [selectedOption];
            }
        }
        else {
            var listOfCachedOptionFromLatestTemplate_1 = this.hiListTemplateOfOption.filter(function (o) { return !!_this.hiListOfSelectedValue.find(function (v) { return _this.compareWith(v, o.hiValue); }); });
            var restSelectedValue_1 = this.hiListOfSelectedValue.filter(function (v) { return !listOfCachedOptionFromLatestTemplate_1.find(function (o) { return _this.compareWith(o.hiValue, v); }); });
            var listOfCachedOptionFromOld = this.listOfCachedSelectedOption.filter(function (o) { return restSelectedValue_1.find(function (v) { return _this.compareWith(o.hiValue, v); }); });
            this.listOfCachedSelectedOption = listOfCachedOptionFromLatestTemplate_1.concat(listOfCachedOptionFromOld);
        }
    };
    HiSelectTopControlComponent.prototype.setInputValue = function (value, emit) {
        this.inputValue = value;
        this.updateWidth();
        this.hiOnSearch.emit({ value: value, emit: emit });
    };
    Object.defineProperty(HiSelectTopControlComponent.prototype, "isSingleMode", {
        get: function () {
            return this.hiMode === 'default';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HiSelectTopControlComponent.prototype, "isMultipleOrTags", {
        get: function () {
            return this.hiMode === 'tags' || this.hiMode === 'multiple';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HiSelectTopControlComponent.prototype, "placeHolderDisplay", {
        get: function () {
            return this.inputValue || this.isComposing || this.hiListOfSelectedValue.length ? 'none' : 'block';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HiSelectTopControlComponent.prototype, "searchDisplay", {
        get: function () {
            return this.hiOpen ? 'block' : 'none';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HiSelectTopControlComponent.prototype, "selectedValueDisplay", {
        get: function () {
            var showSelectedValue = false;
            var opacity = 1;
            if (!this.hiShowSearch) {
                showSelectedValue = true;
            }
            else {
                if (this.hiOpen) {
                    showSelectedValue = !(this.inputValue || this.isComposing);
                    if (showSelectedValue) {
                        opacity = 0.4;
                    }
                }
                else {
                    showSelectedValue = true;
                }
            }
            return {
                display: showSelectedValue ? 'block' : 'none',
                opacity: "" + opacity
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HiSelectTopControlComponent.prototype, "singleValueLabel", {
        get: function () {
            return this.getPropertyFromValue(this.hiListOfSelectedValue[0], 'hiLabel');
        },
        enumerable: true,
        configurable: true
    });
    HiSelectTopControlComponent.prototype.focusOnInput = function () {
        var _this = this;
        setTimeout(function () {
            if (_this.inputElement) {
                _this.inputElement.nativeElement.focus();
            }
        });
    };
    // tslint:disable-next-line:no-any
    // tslint:disable-next-line:no-any
    HiSelectTopControlComponent.prototype.getPropertyFromValue = 
    // tslint:disable-next-line:no-any
    function (value, prop) {
        var _this = this;
        var targetOption = this.listOfCachedSelectedOption.find(function (item) { return _this.compareWith(item.hiValue, value); });
        return targetOption ? targetOption[prop] : '';
    };
    // tslint:disable-next-line:no-any
    // tslint:disable-next-line:no-any
    HiSelectTopControlComponent.prototype.isOptionDisplay = 
    // tslint:disable-next-line:no-any
    function (value) {
        return (this.hiMode === 'tags') || !!this.getPropertyFromValue(value, 'hiLabel');
    };
    // tslint:disable-next-line:no-any
    // tslint:disable-next-line:no-any
    HiSelectTopControlComponent.prototype.removeValueFormSelected = 
    // tslint:disable-next-line:no-any
    function (value) {
        if (this.hiDisabled || this.getPropertyFromValue(value, 'hiDisabled')) {
            return;
        }
        this._listOfSelectedValue = this.hiListOfSelectedValue.filter(function (item) { return item !== value; });
        this.hiListOfSelectedValueChange.emit(this.hiListOfSelectedValue);
    };
    HiSelectTopControlComponent.prototype.updateWidth = function () {
        if (this.isMultipleOrTags && this.inputElement) {
            if (this.inputValue || this.isComposing) {
                this.renderer.setStyle(this.inputElement.nativeElement, 'width', this.inputElement.nativeElement.scrollWidth + "px");
            }
            else {
                this.renderer.removeStyle(this.inputElement.nativeElement, 'width');
            }
        }
    };
    HiSelectTopControlComponent.prototype.onKeyDownInput = function (e) {
        var keyCode = e.keyCode;
        var eventTarget = e.target;
        if (this.isMultipleOrTags &&
            !eventTarget.value &&
            // BackSpace
            keyCode === 8) {
            e.preventDefault();
            if (this.hiListOfSelectedValue.length) {
                this.removeValueFormSelected(this.hiListOfSelectedValue[this.hiListOfSelectedValue.length - 1]);
            }
        }
    };
    HiSelectTopControlComponent.decorators = [
        { type: Component, args: [{
                    selector: '[hi-select-top-control]',
                    preserveWhitespaces: false,
                    animations: [
                        trigger('tagAnimation', [
                            state('*', style({ opacity: 1, transform: 'scale(1)' })),
                            transition('void => *', [
                                style({ opacity: 0, transform: 'scale(0)' }),
                                animate('150ms linear')
                            ]),
                            state('void', style({ opacity: 0, transform: 'scale(0)' })),
                            transition('* => void', [
                                style({ opacity: 1, transform: 'scale(1)' }),
                                animate('150ms linear')
                            ])
                        ])
                    ],
                    template: "\n    <ng-template #inputTemplate>\n      <input\n        #inputElement\n        autocomplete=\"off\"\n        class=\"ant-select-search__field\"\n        (compositionstart)=\"isComposing = true\"\n        (compositionend)=\"isComposing = false\"\n        (input)=\"updateWidth()\"\n        (keydown)=\"onKeyDownInput($event)\"\n        [ngModel]=\"inputValue\"\n        (ngModelChange)=\"setInputValue($event,true)\"\n        [disabled]=\"hiDisabled\">\n    </ng-template>\n    <div\n      *ngIf=\"hiPlaceHolder\"\n      hi-select-unselectable\n      [style.display]=\"placeHolderDisplay\"\n      (click)=\"focusOnInput()\"\n      class=\"ant-select-selection__placeholder\">\n      {{ hiPlaceHolder }}\n    </div>\n    <!--single mode-->\n    <ng-container *ngIf=\"isSingleMode\">\n      <!--selected label-->\n      <div\n        *ngIf=\"hiListOfSelectedValue.length\"\n        class=\"ant-select-selection-selected-value\"\n        [attr.title]=\"hiListOfSelectedValue[0].hiLabel\"\n        [ngStyle]=\"selectedValueDisplay\">\n        {{ singleValueLabel }}\n      </div>\n      <!--show search-->\n      <div\n        *ngIf=\"hiShowSearch\"\n        [style.display]=\"searchDisplay\"\n        class=\"ant-select-search ant-select-search--inline\">\n        <div class=\"ant-select-search__field__wrap\">\n          <ng-template [ngTemplateOutlet]=\"inputTemplate\"></ng-template>\n          <span class=\"ant-select-search__field__mirror\">{{inputValue}}&nbsp;</span>\n        </div>\n      </div>\n    </ng-container>\n    <!--multiple or tags mode-->\n    <ul *ngIf=\"isMultipleOrTags\">\n      <ng-container *ngFor=\"let value of hiListOfSelectedValue\">\n        <li\n          *ngIf=\"isOptionDisplay(value)\"\n          [@tagAnimation]\n          [attr.title]=\"getPropertyFromValue(value,'hiLabel')\"\n          [class.ant-select-selection__choice__disabled]=\"getPropertyFromValue(value,'hiDisabled')\"\n          class=\"ant-select-selection__choice\">\n          <div class=\"ant-select-selection__choice__content\">{{ getPropertyFromValue(value, 'hiLabel') || value }}</div>\n          <span *ngIf=\"!getPropertyFromValue(value,'hiDisabled')\" class=\"ant-select-selection__choice__remove\" (click)=\"removeValueFormSelected(value)\"></span>\n        </li>\n      </ng-container>\n\n      <li class=\"ant-select-search ant-select-search--inline\">\n        <ng-template [ngTemplateOutlet]=\"inputTemplate\"></ng-template>\n      </li>\n    </ul>\n  ",
                    host: {
                        '[class.ant-select-selection__rendered]': 'true'
                    }
                },] },
    ];
    /** @nocollapse */
    HiSelectTopControlComponent.ctorParameters = function () { return [
        { type: Renderer2, },
    ]; };
    HiSelectTopControlComponent.propDecorators = {
        "inputElement": [{ type: ViewChild, args: ['inputElement',] },],
        "hiListOfSelectedValueChange": [{ type: Output },],
        "hiOnSearch": [{ type: Output },],
        "hiMode": [{ type: Input },],
        "hiShowSearch": [{ type: Input },],
        "hiDisabled": [{ type: Input },],
        "hiPlaceHolder": [{ type: Input },],
        "hiOpen": [{ type: Input },],
        "compareWith": [{ type: Input },],
        "hiListOfSelectedValue": [{ type: Input },],
        "hiListTemplateOfOption": [{ type: Input },],
    };
    return HiSelectTopControlComponent;
}());
export { HiSelectTopControlComponent };
