import { CdkConnectedOverlay, CdkOverlayOrigin, ConnectedOverlayPositionChange } from '@angular/cdk/overlay';
import { AfterViewInit, EventEmitter, OnDestroy, OnInit, QueryList, Renderer2 } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { HiOptionContainerComponent } from './hi-option-container.component';
import { HiOptionGroupComponent } from './hi-option-group.component';
import { HiOptionComponent } from './hi-option.component';
import { TFilterOption } from './hi-option.pipe';
import { HiSelectTopControlComponent } from './hi-select-top-control.component';
export declare class HiSelectComponent implements ControlValueAccessor, OnInit, AfterViewInit, OnDestroy {
    private renderer;
    private _disabled;
    private _allowClear;
    private _showSearch;
    private _open;
    private _placeholder;
    private _autoFocus;
    private _dropdownClassName;
    onChange: (value: string | string[]) => void;
    onTouched: () => void;
    dropDownPosition: 'top' | 'center' | 'bottom';
    listOfSelectedValue: any[];
    listOfTemplateOption: HiOptionComponent[];
    value: any | any[];
    overlayWidth: number;
    overlayMinWidth: number;
    searchValue: string;
    isDestroy: boolean;
    isInit: boolean;
    dropDownClassMap: any;
    cdkOverlayOrigin: CdkOverlayOrigin;
    cdkConnectedOverlay: CdkConnectedOverlay;
    hiSelectTopControlComponent: HiSelectTopControlComponent;
    hiOptionContainerComponent: HiOptionContainerComponent;
    /** should move to hi-option-container when https://github.com/angular/angular/issues/20810 resolved **/
    listOfHiOptionComponent: QueryList<HiOptionComponent>;
    listOfHiOptionGroupComponent: QueryList<HiOptionGroupComponent>;
    hiOnSearch: EventEmitter<string>;
    hiScrollToBottom: EventEmitter<void>;
    hiOpenChange: EventEmitter<boolean>;
    hiSize: string;
    hiServerSearch: boolean;
    hiMode: 'default' | 'multiple' | 'tags';
    hiDropdownMatchSelectWidth: boolean;
    hiFilterOption: TFilterOption;
    hiMaxMultipleCount: number;
    hiDropdownStyle: {
        [key: string]: string;
    };
    hiNotFoundContent: string;
    /** https://github.com/angular/angular/pull/13349/files **/
    compareWith: (o1: any, o2: any) => boolean;
    hiDropdownClassName: string;
    hiAutoFocus: boolean;
    hiOpen: boolean;
    hiDisabled: boolean;
    hiAllowClear: boolean;
    hiShowSearch: boolean;
    hiPlaceHolder: string;
    onClick(): void;
    updateAutoFocus(): void;
    focus(): void;
    blur(): void;
    /** overlay can not be always open , reopen overlay after press esc **/
    handleEscBug(): void;
    onKeyDownCdkOverlayOrigin(e: KeyboardEvent): void;
    closeDropDown(): void;
    onPositionChange(position: ConnectedOverlayPositionChange): void;
    onClickOptionFromOptionContainer(): void;
    updateCdkConnectedOverlayStatus(): void;
    updateCdkConnectedOverlayPositions(): void;
    readonly isSingleMode: boolean;
    readonly isMultipleOrTags: boolean;
    /** option container hiListOfSelectedValueChange -> update ngModel **/
    updateListOfSelectedValueFromOptionContainer(value: any[]): void;
    /** option container hiListOfSelectedValueChange -> update ngModel **/
    updateListOfSelectedValueFromTopControl(value: any[]): void;
    updateFromSelectedList(value: any[]): void;
    onSearch(value: string, emit: boolean): void;
    clearNgModel(): void;
    updateNgModel(list: any[], value: string | string[]): void;
    listOfTemplateOptionChange(value: HiOptionComponent[]): void;
    updateDropDownClassMap(): void;
    onClearSelection(e: MouseEvent): void;
    clearSearchValue(): void;
    constructor(renderer: Renderer2);
    /** update ngModel -> update listOfSelectedValue **/
    writeValue(value: any | any[]): void;
    registerOnChange(fn: (value: string | string[]) => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState(isDisabled: boolean): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
}
