var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { ChangeDetectorRef, Component, EventEmitter, Input, Output } from '@angular/core';
import { fadeAnimation } from '../common/animation/fade-animations';
import { toBoolean } from '../utils/convert';
import { TooltipComponent } from '../tooltip/tooltip.component';
var PopconfirmComponent = /** @class */ (function (_super) {
    __extends(PopconfirmComponent, _super);
    function PopconfirmComponent(cdr) {
        var _this = _super.call(this, cdr) || this;
        _this._condition = false;
        _this._prefix = 'hi-popover-placement';
        _this._trigger = 'click';
        _this._hasBackdrop = true;
        _this.option = {
            okText: '确定',
            cancelText: '取消'
        };
        _this.hiOnCancel = new EventEmitter();
        _this.hiOnConfirm = new EventEmitter();
        return _this;
    }
    Object.defineProperty(PopconfirmComponent.prototype, "hiCondition", {
        set: function (value) {
            this._condition = toBoolean(value);
        },
        enumerable: true,
        configurable: true
    });
    PopconfirmComponent.prototype.show = function () {
        if (!this._condition) {
            this.hiVisible = true;
        }
        else {
            this.onConfirm();
        }
    };
    PopconfirmComponent.prototype.onCancel = function () {
        this.hiOnCancel.emit();
        this.hiVisible = false;
    };
    PopconfirmComponent.prototype.onConfirm = function () {
        this.hiOnConfirm.emit();
        this.hiVisible = false;
    };
    PopconfirmComponent.decorators = [
        { type: Component, args: [{
                    selector: 'hi-popconfirm',
                    preserveWhitespaces: false,
                    animations: [fadeAnimation],
                    template: "\n    <ng-content></ng-content><ng-template #overlay=\"cdkConnectedOverlay\" cdkConnectedOverlay [cdkConnectedOverlayOrigin]=\"overlayOrigin\" [cdkConnectedOverlayHasBackdrop]=\"_hasBackdrop\" (backdropClick)=\"hide()\" (detach)=\"hide()\" (positionChange)=\"onPositionChange($event)\" [cdkConnectedOverlayPositions]=\"_positions\" [cdkConnectedOverlayOpen]=\"visible$ | async\"><div class=\"hi-popover\" [ngClass]=\"_classMap\" [ngStyle]=\"hiOverlayStyle\" [@fadeAnimation]=\"''+(visible$ | async)\" (@fadeAnimation.done)=\"_afterVisibilityAnimation($event)\"><div class=\"hi-popover-content\"><div class=\"hi-popover-arrow\"></div><div class=\"hi-popover-inner\"><div><div class=\"hi-popover-inner-content\"><div class=\"hi-popover-message\" *ngIf=\"!hiTemplate\"><i class=\"anticon anticon-exclamation-circle\"></i><div class=\"hi-popover-message-title\">{{ hiTitle }}</div></div><div class=\"hi-popover-buttons\" *ngIf=\"!hiTemplate\"><button type=\"button\" class=\"btn btn-light btn-sm\" (click)=\"onCancel()\"><ng-container *ngIf=\"hiCancelText\">{{ hiCancelText }}</ng-container><ng-container *ngIf=\"!hiCancelText\">{{ option.cancelText}}</ng-container></button> <button type=\"button\" class=\"btn btn-primary btn-sm\" (click)=\"onConfirm()\"><ng-container *ngIf=\"hiOkText\">{{ hiOkText }}</ng-container><ng-container *ngIf=\"!hiOkText\">{{ option.okText}}</ng-container></button></div><ng-template *ngIf=\"hiTemplate\" [ngTemplateOutlet]=\"hiTemplate\"></ng-template></div></div></div></div></div></ng-template>\n  ",
                    styles: ["\n    .hi-popover {\n      position: relative;\n    }\n  "]
                },] },
    ];
    /** @nocollapse */
    PopconfirmComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef, },
    ]; };
    PopconfirmComponent.propDecorators = {
        "hiContent": [{ type: Input },],
        "hiOkText": [{ type: Input },],
        "hiCancelText": [{ type: Input },],
        "hiCondition": [{ type: Input },],
        "hiOnCancel": [{ type: Output },],
        "hiOnConfirm": [{ type: Output },],
    };
    return PopconfirmComponent;
}(TooltipComponent));
export { PopconfirmComponent };
